/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-10.2.1-20200826/gcc/config/sh/sh.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-10.2.1-20200826/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-10.2.1-20200826/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-10.2.1-20200826/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-10.2.1-20200826/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-10.2.1-20200826/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-10.2.1-20200826/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-10.2.1-20200826/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I08 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 105 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= -128 && ival <= 127));
}
static inline bool
satisfies_constraint_I16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 110 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= -32768 && ival <= 32767));
}
static inline bool
satisfies_constraint_I20 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 115 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= -524288 && ival <= 524287)) && (
#line 116 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(TARGET_SH2A)));
}
static inline bool
satisfies_constraint_I28 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 121 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >=  -134217728 && ival <= 134217727)) && ((
#line 122 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
((ival & 255) == 0)) && (
#line 123 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(TARGET_SH2A))));
}
static inline bool
satisfies_constraint_Jmb (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 128 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 0xFF));
}
static inline bool
satisfies_constraint_Jmw (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 133 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 0xFFFF));
}
static inline bool
satisfies_constraint_Jhb (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 138 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
((ival & 0xFFFFFFFF) == 0x80000000));
}
static inline bool
satisfies_constraint_K03 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 143 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= 0 && ival <= 7));
}
static inline bool
satisfies_constraint_K04 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 148 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= 0 && ival <= 15));
}
static inline bool
satisfies_constraint_K05 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 153 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= 0 && ival <= 31));
}
static inline bool
satisfies_constraint_K08 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 158 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= 0 && ival <= 255));
}
static inline bool
satisfies_constraint_K12 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 164 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= 0 && ival <= 4095));
}
static inline bool
satisfies_constraint_K13 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 170 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival >= 0 && ival <= 8191));
}
static inline bool
satisfies_constraint_P27 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 175 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 1 || ival == 2 || ival == 8 || ival == 16));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 180 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 1));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 185 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 191 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(fp_zero_operand (op)));
}
static inline bool
satisfies_constraint_H (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 196 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(fp_one_operand (op)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 202 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(GET_MODE (op) != QImode)) && (
#line 203 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(IS_PC_RELATIVE_LOAD_ADDR_P (XEXP (op, 0)))));
}
static inline bool
satisfies_constraint_Bsc (rtx op)
{
  return GET_CODE (op) == SCRATCH;
}
static inline bool
satisfies_constraint_Ccl (rtx op)
{
  return (GET_CODE (op) == UNSPEC) && (
#line 214 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(XINT (op, 1) == UNSPEC_CALLER));
}
static inline bool
satisfies_constraint_Csy (rtx op)
{
  return (
#line 218 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(NON_PIC_REFERENCE_P (op))) || (
#line 219 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(PIC_ADDR_P (op)));
}
static inline bool
satisfies_constraint_Z (rtx op)
{
  return 
#line 223 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(op == CONST0_RTX (GET_MODE (op)));
}
static inline bool
satisfies_constraint_W (rtx op)
{
  return (GET_CODE (op) == CONST_VECTOR) && ((
#line 228 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(sh_rep_vec (op, VOIDmode))) || (
#line 229 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(HOST_BITS_PER_WIDE_INT >= 64
			 ? sh_const_vec (op, VOIDmode)
			 : sh_1el_vec (op, VOIDmode))));
}
static inline bool
satisfies_constraint_Cpg (rtx op)
{
  return 
#line 237 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(IS_NON_EXPLICIT_CONSTANT_P (op));
}
static inline bool
satisfies_constraint_Pso (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 242 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 1)) || ((
#line 243 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 2)) || ((
#line 244 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 4)) || ((
#line 245 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 8)) || ((
#line 246 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 16)) || ((
#line 247 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 32)) || ((
#line 248 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 64)) || (
#line 249 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(ival == 128)))))))));
}
static inline bool
satisfies_constraint_Psz (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 254 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 1)) || ((
#line 255 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 2)) || ((
#line 256 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 4)) || ((
#line 257 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 8)) || ((
#line 258 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 16)) || ((
#line 259 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 32)) || ((
#line 260 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 64)) || (
#line 261 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(~ival == 128)))))))));
}
static inline bool
satisfies_constraint_Sua (rtx op)
{
  return (
#line 265 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(memory_operand (op, GET_MODE (op)))) && (
#line 266 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(GET_CODE (XEXP (op, 0)) != PLUS));
}
static inline bool
satisfies_constraint_Sdd (rtx op)
{
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && (GET_CODE (XEXP (XEXP (op, 0), 1)) == CONST_INT)));
}
static inline bool
satisfies_constraint_Snd (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 278 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(! satisfies_constraint_Sdd (op)));
}
static inline bool
satisfies_constraint_Sid (rtx op)
{
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && (GET_CODE (XEXP (XEXP (op, 0), 1)) == REG)));
}
static inline bool
satisfies_constraint_Ssd (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 290 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(! satisfies_constraint_Sid (op))) && (
#line 291 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(! satisfies_constraint_Sdd (op))));
}
static inline bool
satisfies_constraint_Sbv (rtx op)
{
  return (
#line 295 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(MEM_P (op) && GET_MODE (op) == QImode)) && (
#line 296 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(REG_P (XEXP (op, 0))));
}
static inline bool
satisfies_constraint_Sbw (rtx op)
{
  return (
#line 300 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(satisfies_constraint_Sdd (op))) && ((
#line 301 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(GET_MODE (op) == QImode)) && (
#line 302 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(satisfies_constraint_K12 (XEXP (XEXP (op, 0), 1)))));
}
static inline bool
satisfies_constraint_Sra (rtx op)
{
  return (GET_CODE (op) == MEM) && (GET_CODE (XEXP (op, 0)) == REG);
}
static inline bool
satisfies_constraint_Ara (rtx op)
{
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == REG) && (
#line 314 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(REGNO (XEXP (op, 0)) != SP_REG)));
}
static inline bool
satisfies_constraint_Add (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 320 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(GET_MODE (op) == SImode)) && ((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && ((GET_CODE (XEXP (XEXP (op, 0), 1)) == CONST_INT) && (
#line 324 "../../gcc-10.2.1-20200826/gcc/config/sh/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) != SP_REG))))));
}
#endif /* tm-constrs.h */
