/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 228:  /* cris_frame_deallocated_barrier */
    case 49:  /* *cris_load_multiple */
      return 0;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 2;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 228:  /* cris_frame_deallocated_barrier */
    case 49:  /* *cris_load_multiple */
      return 0;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 2;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_slottable cached_slottable ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 189:  /* *return_expanded */
      extract_constrain_insn_cached (insn);
      if (! (
#line 3516 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(cris_return_address_on_stack_for_return ())))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 225:  /* *expanded_call_value_v32 */
    case 221:  /* *expanded_call_v32 */
    case 209:  /* *bge_reversed */
    case 208:  /* *blt_reversed */
    case 207:  /* *ble_reversed */
    case 206:  /* *bgt_reversed */
    case 205:  /* *bleu_reversed */
    case 204:  /* *bgeu_reversed */
    case 203:  /* *bltu_reversed */
    case 202:  /* *bgtu_reversed */
    case 201:  /* *bne_reversed */
    case 200:  /* *beq_reversed */
    case 199:  /* bge */
    case 198:  /* blt */
    case 197:  /* ble */
    case 196:  /* bgt */
    case 195:  /* bleu */
    case 194:  /* bgeu */
    case 193:  /* bltu */
    case 192:  /* bgtu */
    case 191:  /* bne */
    case 190:  /* beq */
    case 188:  /* *indirect_jump_v32 */
    case 186:  /* jump */
    case 118:  /* *casesi_jump_v32 */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if ((cached_slottable = get_attr_slottable (insn)) == SLOTTABLE_HAS_RETURN_SLOT)
        {
	  return 1;
        }
      else if (cached_slottable == SLOTTABLE_HAS_CALL_SLOT)
        {
	  return 1;
        }
      else if (cached_slottable == SLOTTABLE_HAS_SLOT)
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    default:
      return 0;

    }
}

enum attr_cc
get_attr_cc (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 149:  /* *iorsi3_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return CC_NOOV32;
        }
      else if (which_alternative == 3)
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NOOV32;
        }

    case 148:  /* *iorsi3_non_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 3)
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 153:  /* *iorqi3_v32 */
    case 145:  /* *andqi3_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_CLOBBER;
        }
      else if (((1ULL << which_alternative) & 0x6ULL))
        {
	  return CC_NOOV32;
        }
      else if (which_alternative == 3)
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NOOV32;
        }

    case 152:  /* *iorqi3_non_v32 */
    case 144:  /* *andqi3_non_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_CLOBBER;
        }
      else if (((1ULL << which_alternative) & 0x6ULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 3)
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 151:  /* *iorhi3_v32 */
    case 141:  /* *expanded_andhi_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_CLOBBER;
        }
      else if (((1ULL << which_alternative) & 0xeULL))
        {
	  return CC_NOOV32;
        }
      else if (which_alternative == 4)
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NOOV32;
        }

    case 150:  /* *iorhi3_non_v32 */
    case 140:  /* *expanded_andhi_non_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_CLOBBER;
        }
      else if (((1ULL << which_alternative) & 0xeULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 4)
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 112:  /* *addsqi_v32 */
    case 111:  /* *addshi_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 107:  /* *addsbw_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NONE;
        }

    case 79:  /* *addqi3_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 1)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 2)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 3)
        {
	  return CC_NONE;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return CC_CLOBBER;
        }
      else if (which_alternative == 6)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 7)
        {
	  return CC_CLOBBER;
        }
      else if (which_alternative == 8)
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 78:  /* *addqi3_non_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_NORMAL;
        }
      else if (((1ULL << which_alternative) & 0x1cULL))
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 77:  /* *addhi3_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 1)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 2)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 3)
        {
	  return CC_NONE;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return CC_CLOBBER;
        }
      else if (which_alternative == 6)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 7)
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 87:  /* *subqi3_v32 */
    case 86:  /* *subhi3_v32 */
    case 85:  /* *subqi3_nonv32 */
    case 84:  /* *subhi3_nonv32 */
    case 76:  /* *addhi3_non_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_NORMAL;
        }
      else if (((1ULL << which_alternative) & 0xcULL))
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 75:  /* *addsi3_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 1)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 2)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 3)
        {
	  return CC_NONE;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 6)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 7)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 8)
        {
	  return CC_NONE;
        }
      else if (((1ULL << which_alternative) & 0xe00ULL))
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 46:  /* movqi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xffULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 8)
        {
	  return CC_CLOBBER;
        }
      else if (which_alternative == 9)
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 44:  /* movhi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_NORMAL;
        }
      else if (((1ULL << which_alternative) & 0xcULL))
        {
	  return CC_NONE;
        }
      else if (which_alternative == 4)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 5)
        {
	  return CC_NONE;
        }
      else if (which_alternative == 6)
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 7)
        {
	  return CC_CLOBBER;
        }
      else if (which_alternative == 8)
        {
	  return CC_NORMAL;
        }
      else if (((1ULL << which_alternative) & 0x600ULL))
        {
	  return CC_NONE;
        }
      else if (which_alternative == 11)
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 37:  /* *movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ffULL))
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_NONE;
        }

    case 17:  /* *movdi_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 2)
        {
	  return CC_CLOBBER;
        }
      else if (which_alternative == 3)
        {
	  return CC_NORMAL;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return CC_CLOBBER;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 14:  /* *cmpqi */
    case 13:  /* *cmphi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 2)
        {
	  return CC_REV;
        }
      else if (which_alternative == 3)
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_REV;
        }

    case 12:  /* *cmpsi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return CC_NORMAL;
        }
      else if (which_alternative == 3)
        {
	  return CC_REV;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return CC_NORMAL;
        }
      else
        {
	  return CC_REV;
        }

    case 5:  /* *tstqi_non_cmp */
    case 4:  /* *tsthi_non_cmp */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_NOOV32;
        }
      else
        {
	  return CC_NORMAL;
        }

    case 175:  /* ashlhi3 */
    case 176:  /* ashlqi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CC_NOOV32;
        }
      else
        {
	  return CC_CLOBBER;
        }

    case 10:  /* *cmp_swapexthi */
    case 11:  /* *cmp_swapextqi */
      return CC_REV;

    case 15:  /* *btst */
    case 132:  /* dstep_shift */
    case 133:  /* dstep_mul */
    case 137:  /* *expanded_andsi_v32 */
    case 143:  /* *andhi_lowpart_v32 */
    case 147:  /* *andqi_lowpart_v32 */
    case 154:  /* xorsi3 */
    case 161:  /* one_cmplsi2 */
    case 164:  /* ashrsi3 */
    case 165:  /* lshrsi3 */
    case 166:  /* ashlsi3 */
    case 167:  /* *expanded_ashrhi */
    case 168:  /* *expanded_lshrhi */
    case 169:  /* *expanded_ashrqi */
    case 170:  /* *expanded_lshrqi */
    case 171:  /* *ashrhi_lowpart */
    case 172:  /* *lshrhi_lowpart */
    case 173:  /* *ashrqi_lowpart */
    case 174:  /* *lshrqi_lowpart */
    case 177:  /* *ashlhi_lowpart */
    case 178:  /* *ashlqi_lowpart */
    case 180:  /* abssi2 */
    case 181:  /* clzsi2 */
    case 182:  /* bswapsi2 */
    case 183:  /* cris_swap_bits */
      return CC_NOOV32;

    case 36:  /* *movsi_got_load */
    case 100:  /* *extopqihi_non_v32 */
    case 101:  /* *extopqihi_v32 */
    case 106:  /* *addxqihi_swap_non_v32 */
    case 108:  /* *addubw_v32 */
    case 117:  /* *casesi_adds_w */
    case 118:  /* *casesi_jump_v32 */
    case 119:  /* addi_mul */
    case 123:  /* mulhisi3 */
    case 124:  /* umulhisi3 */
    case 125:  /* mulqihi3 */
    case 126:  /* umulqihi3 */
    case 127:  /* mulsi3 */
    case 130:  /* smulsi3_highpart */
    case 131:  /* umulsi3_highpart */
    case 155:  /* xorhi3 */
    case 156:  /* xorqi3 */
    case 162:  /* one_cmplhi2 */
    case 163:  /* one_cmplqi2 */
    case 223:  /* *expanded_call_value_non_v32 */
    case 224:  /* *expanded_call_value_side */
    case 225:  /* *expanded_call_value_v32 */
      return CC_CLOBBER;

    case 49:  /* *cris_load_multiple */
    case 50:  /* *cris_store_multiple */
    case 120:  /* *addi */
    case 135:  /* *andsi_clear */
    case 139:  /* *andhi_clear */
    case 210:  /* seq */
    case 211:  /* sne */
    case 212:  /* sgtu */
    case 213:  /* sltu */
    case 214:  /* sgeu */
    case 215:  /* sleu */
    case 216:  /* slt */
    case 217:  /* sge */
    case 218:  /* sgt */
    case 219:  /* sle */
    case 226:  /* nop */
      return CC_NONE;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return CC_NORMAL;

    }
}

enum attr_slottable
get_attr_slottable (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 151:  /* *iorhi3_v32 */
    case 150:  /* *iorhi3_non_v32 */
    case 141:  /* *expanded_andhi_v32 */
    case 140:  /* *expanded_andhi_non_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (which_alternative == 3)
        {
	  return SLOTTABLE_NO;
        }
      else if (which_alternative == 4)
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 79:  /* *addqi3_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xffULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 77:  /* *addhi3_v32 */
    case 75:  /* *addsi3_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7fULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 74:  /* *addsi3_non_v32 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xfULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (((1ULL << which_alternative) & 0xf0ULL))
        {
	  return SLOTTABLE_NO;
        }
      else
        {
	  return SLOTTABLE_YES;
        }

    case 48:  /* movsf */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x1fULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (((1ULL << which_alternative) & 0xe0ULL))
        {
	  return SLOTTABLE_NO;
        }
      else if (((1ULL << which_alternative) & 0x700ULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (which_alternative == 11)
        {
	  return SLOTTABLE_NO;
        }
      else if (which_alternative == 12)
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 46:  /* movqi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (((1ULL << which_alternative) & 0xc0ULL))
        {
	  return SLOTTABLE_NO;
        }
      else if (which_alternative == 8)
        {
	  return SLOTTABLE_YES;
        }
      else if (which_alternative == 9)
        {
	  return SLOTTABLE_NO;
        }
      else
        {
	  return SLOTTABLE_YES;
        }

    case 78:  /* *addqi3_non_v32 */
    case 47:  /* movstrictqi */
    case 45:  /* movstricthi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x1fULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 44:  /* movhi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (which_alternative == 6)
        {
	  return SLOTTABLE_NO;
        }
      else if (which_alternative == 7)
        {
	  return SLOTTABLE_YES;
        }
      else if (((1ULL << which_alternative) & 0xf00ULL))
        {
	  return SLOTTABLE_NO;
        }
      else
        {
	  return SLOTTABLE_YES;
        }

    case 37:  /* *movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return SLOTTABLE_YES;
        }
      else if (((1ULL << which_alternative) & 0x7c0ULL))
        {
	  return SLOTTABLE_NO;
        }
      else if (((1ULL << which_alternative) & 0x1800ULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 149:  /* *iorsi3_v32 */
    case 148:  /* *iorsi3_non_v32 */
    case 137:  /* *expanded_andsi_v32 */
    case 136:  /* *expanded_andsi_non_v32 */
    case 14:  /* *cmpqi */
    case 13:  /* *cmphi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 153:  /* *iorqi3_v32 */
    case 152:  /* *iorqi3_non_v32 */
    case 145:  /* *andqi3_v32 */
    case 144:  /* *andqi3_non_v32 */
    case 135:  /* *andsi_clear */
    case 87:  /* *subqi3_v32 */
    case 86:  /* *subhi3_v32 */
    case 85:  /* *subqi3_nonv32 */
    case 84:  /* *subhi3_nonv32 */
    case 83:  /* *subsi3_v32 */
    case 82:  /* *subsi3_non_v32 */
    case 76:  /* *addhi3_non_v32 */
    case 12:  /* *cmpsi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xfULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 184:  /* *uminsi3_non_v32 */
    case 147:  /* *andqi_lowpart_v32 */
    case 146:  /* *andqi_lowpart_non_v32 */
    case 143:  /* *andhi_lowpart_v32 */
    case 142:  /* *andhi_lowpart_non_v32 */
    case 139:  /* *andhi_clear */
    case 138:  /* *andhi_movu */
    case 134:  /* *andsi_movu */
    case 131:  /* umulsi3_highpart */
    case 130:  /* smulsi3_highpart */
    case 110:  /* *extopqisi_swap_non_v32 */
    case 109:  /* *extophisi_swap_non_v32 */
    case 106:  /* *addxqihi_swap_non_v32 */
    case 103:  /* *extopqisi_non_v32 */
    case 102:  /* *extophisi_non_v32 */
    case 100:  /* *extopqihi_non_v32 */
    case 59:  /* zero_extendqihi2 */
    case 58:  /* zero_extendqisi2 */
    case 57:  /* zero_extendhisi2 */
    case 56:  /* extendqihi2 */
    case 55:  /* extendqisi2 */
    case 54:  /* extendhisi2 */
    case 5:  /* *tstqi_non_cmp */
    case 4:  /* *tsthi_non_cmp */
    case 1:  /* *tstsi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 2:  /* *tsthi_cmp */
    case 3:  /* *tstqi_cmp */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return SLOTTABLE_NO;
        }
      else if (which_alternative == 1)
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 123:  /* mulhisi3 */
    case 124:  /* umulhisi3 */
    case 125:  /* mulqihi3 */
    case 126:  /* umulqihi3 */
    case 127:  /* mulsi3 */
      extract_constrain_insn_cached (insn);
      if (
#line 2615 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(TARGET_MUL_BUG))
        {
	  return SLOTTABLE_NO;
        }
      else
        {
	  return SLOTTABLE_YES;
        }

    case 8:  /* *cmp_exthi */
    case 9:  /* *cmp_extqi */
    case 10:  /* *cmp_swapexthi */
    case 11:  /* *cmp_swapextqi */
    case 49:  /* *cris_load_multiple */
    case 50:  /* *cris_store_multiple */
    case 185:  /* *uminsi3_v32 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return SLOTTABLE_YES;
        }
      else
        {
	  return SLOTTABLE_NO;
        }

    case 189:  /* *return_expanded */
      extract_constrain_insn_cached (insn);
      if (
#line 3516 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(cris_return_address_on_stack_for_return ()))
        {
	  return SLOTTABLE_NO;
        }
      else
        {
	  return SLOTTABLE_HAS_RETURN_SLOT;
        }

    case 221:  /* *expanded_call_v32 */
    case 225:  /* *expanded_call_value_v32 */
      return SLOTTABLE_HAS_CALL_SLOT;

    case 118:  /* *casesi_jump_v32 */
    case 186:  /* jump */
    case 188:  /* *indirect_jump_v32 */
    case 190:  /* beq */
    case 191:  /* bne */
    case 192:  /* bgtu */
    case 193:  /* bltu */
    case 194:  /* bgeu */
    case 195:  /* bleu */
    case 196:  /* bgt */
    case 197:  /* ble */
    case 198:  /* blt */
    case 199:  /* bge */
    case 200:  /* *beq_reversed */
    case 201:  /* *bne_reversed */
    case 202:  /* *bgtu_reversed */
    case 203:  /* *bltu_reversed */
    case 204:  /* *bgeu_reversed */
    case 205:  /* *bleu_reversed */
    case 206:  /* *bgt_reversed */
    case 207:  /* *ble_reversed */
    case 208:  /* *blt_reversed */
    case 209:  /* *bge_reversed */
      return SLOTTABLE_HAS_SLOT;

    case 15:  /* *btst */
    case 101:  /* *extopqihi_v32 */
    case 104:  /* *extophisi_v32 */
    case 105:  /* *extopqisi_v32 */
    case 107:  /* *addsbw_v32 */
    case 108:  /* *addubw_v32 */
    case 111:  /* *addshi_v32 */
    case 112:  /* *addsqi_v32 */
    case 113:  /* *adduhi_v32 */
    case 114:  /* *adduqi_v32 */
    case 115:  /* *boundhi_v32 */
    case 116:  /* *boundqi_v32 */
    case 119:  /* addi_mul */
    case 120:  /* *addi */
    case 121:  /* mstep_shift */
    case 122:  /* mstep_mul */
    case 132:  /* dstep_shift */
    case 133:  /* dstep_mul */
    case 154:  /* xorsi3 */
    case 155:  /* xorhi3 */
    case 156:  /* xorqi3 */
    case 157:  /* *expanded_negsf2 */
    case 158:  /* negsi2 */
    case 159:  /* neghi2 */
    case 160:  /* negqi2 */
    case 161:  /* one_cmplsi2 */
    case 162:  /* one_cmplhi2 */
    case 163:  /* one_cmplqi2 */
    case 164:  /* ashrsi3 */
    case 165:  /* lshrsi3 */
    case 166:  /* ashlsi3 */
    case 167:  /* *expanded_ashrhi */
    case 168:  /* *expanded_lshrhi */
    case 169:  /* *expanded_ashrqi */
    case 170:  /* *expanded_lshrqi */
    case 171:  /* *ashrhi_lowpart */
    case 172:  /* *lshrhi_lowpart */
    case 173:  /* *ashrqi_lowpart */
    case 174:  /* *lshrqi_lowpart */
    case 175:  /* ashlhi3 */
    case 176:  /* ashlqi3 */
    case 177:  /* *ashlhi_lowpart */
    case 178:  /* *ashlqi_lowpart */
    case 180:  /* abssi2 */
    case 181:  /* clzsi2 */
    case 182:  /* bswapsi2 */
    case 183:  /* cris_swap_bits */
    case 210:  /* seq */
    case 211:  /* sne */
    case 212:  /* sgtu */
    case 213:  /* sltu */
    case 214:  /* sgeu */
    case 215:  /* sleu */
    case 216:  /* slt */
    case 217:  /* sge */
    case 218:  /* sgt */
    case 219:  /* sle */
      return SLOTTABLE_YES;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return SLOTTABLE_NO;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 1);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = delay_insn;
  switch (recog_memoized (insn))
    {
    case 225:  /* *expanded_call_value_v32 */
    case 221:  /* *expanded_call_v32 */
      slot += 2 * 1;
      break;
      break;

    case 189:  /* *return_expanded */
      extract_constrain_insn_cached (insn);
      if (! (
#line 3516 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(cris_return_address_on_stack_for_return ())))
        {
	  slot += 3 * 1;
      break;
        }
      else
        {
	  slot += 0 * 1;
      break;
        }
      break;

    case 209:  /* *bge_reversed */
    case 208:  /* *blt_reversed */
    case 207:  /* *ble_reversed */
    case 206:  /* *bgt_reversed */
    case 205:  /* *bleu_reversed */
    case 204:  /* *bgeu_reversed */
    case 203:  /* *bltu_reversed */
    case 202:  /* *bgtu_reversed */
    case 201:  /* *bne_reversed */
    case 200:  /* *beq_reversed */
    case 199:  /* bge */
    case 198:  /* blt */
    case 197:  /* ble */
    case 196:  /* bgt */
    case 195:  /* bleu */
    case 194:  /* bgeu */
    case 193:  /* bltu */
    case 192:  /* bgtu */
    case 191:  /* bne */
    case 190:  /* beq */
    case 188:  /* *indirect_jump_v32 */
    case 186:  /* jump */
    case 118:  /* *casesi_jump_v32 */
      slot += 1 * 1;
      break;
      break;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (get_attr_slottable (insn) == SLOTTABLE_HAS_RETURN_SLOT)
        {
	  slot += 3 * 1;
      break;
        }
      else if (get_attr_slottable (insn) == SLOTTABLE_HAS_CALL_SLOT)
        {
	  slot += 2 * 1;
      break;
        }
      else if (get_attr_slottable (insn) == SLOTTABLE_HAS_SLOT)
        {
	  slot += 1 * 1;
      break;
        }
      else
        {
	  slot += 0 * 1;
      break;
        }
      break;

    default:
      slot += 0 * 1;
      break;
      break;

    }

  gcc_assert (slot >= 1);

  insn = candidate_insn;
  switch (slot)
    {
    case 3:
      switch (recog_memoized (insn))
	{
        case 151:  /* *iorhi3_v32 */
        case 150:  /* *iorhi3_non_v32 */
        case 141:  /* *expanded_andhi_v32 */
        case 140:  /* *expanded_andhi_non_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x17ULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 127:  /* mulsi3 */
        case 126:  /* umulqihi3 */
        case 125:  /* mulqihi3 */
        case 124:  /* umulhisi3 */
        case 123:  /* mulhisi3 */
	  extract_constrain_insn_cached (insn);
	  if ((! (
#line 2615 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(TARGET_MUL_BUG))) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 79:  /* *addqi3_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0xffULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 77:  /* *addhi3_v32 */
        case 75:  /* *addsi3_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x7fULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 74:  /* *addsi3_non_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((!((1ULL << which_alternative) & 0xf0ULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 48:  /* movsf */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x171fULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 46:  /* movqi */
	  extract_constrain_insn_cached (insn);
	  if ((!((1ULL << which_alternative) & 0x2c0ULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 78:  /* *addqi3_non_v32 */
        case 47:  /* movstrictqi */
        case 45:  /* movstricthi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x1fULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 44:  /* movhi */
	  extract_constrain_insn_cached (insn);
	  if ((!((1ULL << which_alternative) & 0xf40ULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 37:  /* *movsi_internal */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x183fULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 219:  /* sle */
        case 218:  /* sgt */
        case 217:  /* sge */
        case 216:  /* slt */
        case 215:  /* sleu */
        case 214:  /* sgeu */
        case 213:  /* sltu */
        case 212:  /* sgtu */
        case 211:  /* sne */
        case 210:  /* seq */
        case 183:  /* cris_swap_bits */
        case 182:  /* bswapsi2 */
        case 181:  /* clzsi2 */
        case 180:  /* abssi2 */
        case 178:  /* *ashlqi_lowpart */
        case 177:  /* *ashlhi_lowpart */
        case 176:  /* ashlqi3 */
        case 175:  /* ashlhi3 */
        case 174:  /* *lshrqi_lowpart */
        case 173:  /* *ashrqi_lowpart */
        case 172:  /* *lshrhi_lowpart */
        case 171:  /* *ashrhi_lowpart */
        case 170:  /* *expanded_lshrqi */
        case 169:  /* *expanded_ashrqi */
        case 168:  /* *expanded_lshrhi */
        case 167:  /* *expanded_ashrhi */
        case 166:  /* ashlsi3 */
        case 165:  /* lshrsi3 */
        case 164:  /* ashrsi3 */
        case 163:  /* one_cmplqi2 */
        case 162:  /* one_cmplhi2 */
        case 161:  /* one_cmplsi2 */
        case 160:  /* negqi2 */
        case 159:  /* neghi2 */
        case 158:  /* negsi2 */
        case 157:  /* *expanded_negsf2 */
        case 156:  /* xorqi3 */
        case 155:  /* xorhi3 */
        case 154:  /* xorsi3 */
        case 133:  /* dstep_mul */
        case 132:  /* dstep_shift */
        case 122:  /* mstep_mul */
        case 121:  /* mstep_shift */
        case 120:  /* *addi */
        case 119:  /* addi_mul */
        case 116:  /* *boundqi_v32 */
        case 115:  /* *boundhi_v32 */
        case 114:  /* *adduqi_v32 */
        case 113:  /* *adduhi_v32 */
        case 112:  /* *addsqi_v32 */
        case 111:  /* *addshi_v32 */
        case 108:  /* *addubw_v32 */
        case 107:  /* *addsbw_v32 */
        case 105:  /* *extopqisi_v32 */
        case 104:  /* *extophisi_v32 */
        case 101:  /* *extopqihi_v32 */
        case 15:  /* *btst */
	  extract_constrain_insn_cached (insn);
	  if (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 149:  /* *iorsi3_v32 */
        case 148:  /* *iorsi3_non_v32 */
        case 137:  /* *expanded_andsi_v32 */
        case 136:  /* *expanded_andsi_non_v32 */
        case 14:  /* *cmpqi */
        case 13:  /* *cmphi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x7ULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 153:  /* *iorqi3_v32 */
        case 152:  /* *iorqi3_non_v32 */
        case 145:  /* *andqi3_v32 */
        case 144:  /* *andqi3_non_v32 */
        case 135:  /* *andsi_clear */
        case 87:  /* *subqi3_v32 */
        case 86:  /* *subhi3_v32 */
        case 85:  /* *subqi3_nonv32 */
        case 84:  /* *subhi3_nonv32 */
        case 83:  /* *subsi3_v32 */
        case 82:  /* *subsi3_non_v32 */
        case 76:  /* *addhi3_non_v32 */
        case 12:  /* *cmpsi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0xfULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 185:  /* *uminsi3_v32 */
        case 50:  /* *cris_store_multiple */
        case 49:  /* *cris_load_multiple */
        case 11:  /* *cmp_swapextqi */
        case 10:  /* *cmp_swapexthi */
        case 9:  /* *cmp_extqi */
        case 8:  /* *cmp_exthi */
	  extract_constrain_insn_cached (insn);
	  if ((which_alternative == 0) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 3:  /* *tstqi_cmp */
        case 2:  /* *tsthi_cmp */
	  extract_constrain_insn_cached (insn);
	  if ((which_alternative == 1) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 184:  /* *uminsi3_non_v32 */
        case 147:  /* *andqi_lowpart_v32 */
        case 146:  /* *andqi_lowpart_non_v32 */
        case 143:  /* *andhi_lowpart_v32 */
        case 142:  /* *andhi_lowpart_non_v32 */
        case 139:  /* *andhi_clear */
        case 138:  /* *andhi_movu */
        case 134:  /* *andsi_movu */
        case 131:  /* umulsi3_highpart */
        case 130:  /* smulsi3_highpart */
        case 110:  /* *extopqisi_swap_non_v32 */
        case 109:  /* *extophisi_swap_non_v32 */
        case 106:  /* *addxqihi_swap_non_v32 */
        case 103:  /* *extopqisi_non_v32 */
        case 102:  /* *extophisi_non_v32 */
        case 100:  /* *extopqihi_non_v32 */
        case 59:  /* zero_extendqihi2 */
        case 58:  /* zero_extendqisi2 */
        case 57:  /* zero_extendhisi2 */
        case 56:  /* extendqihi2 */
        case 55:  /* extendqisi2 */
        case 54:  /* extendhisi2 */
        case 5:  /* *tstqi_non_cmp */
        case 4:  /* *tsthi_non_cmp */
        case 1:  /* *tstsi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x3ULL)) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case -1:
	  if (GET_CODE (PATTERN (insn)) != ASM_INPUT
	      && asm_noperands (PATTERN (insn)) < 0)
	    fatal_insn_not_found (insn);
	  /* FALLTHRU */
	  extract_constrain_insn_cached (insn);
	  if ((get_attr_slottable (insn) == SLOTTABLE_YES) && (! (
#line 204 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(dead_or_set_regno_p (insn, CRIS_SRP_REGNUM)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        default:
	  return 0;

      }
    case 2:
      switch (recog_memoized (insn))
	{
        case 151:  /* *iorhi3_v32 */
        case 150:  /* *iorhi3_non_v32 */
        case 141:  /* *expanded_andhi_v32 */
        case 140:  /* *expanded_andhi_non_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x17ULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 127:  /* mulsi3 */
        case 126:  /* umulqihi3 */
        case 125:  /* mulqihi3 */
        case 124:  /* umulhisi3 */
        case 123:  /* mulhisi3 */
	  extract_constrain_insn_cached (insn);
	  if ((! (
#line 2615 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(TARGET_MUL_BUG))) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 79:  /* *addqi3_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0xffULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 77:  /* *addhi3_v32 */
        case 75:  /* *addsi3_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x7fULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 74:  /* *addsi3_non_v32 */
	  extract_constrain_insn_cached (insn);
	  if ((!((1ULL << which_alternative) & 0xf0ULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 48:  /* movsf */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x171fULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 46:  /* movqi */
	  extract_constrain_insn_cached (insn);
	  if ((!((1ULL << which_alternative) & 0x2c0ULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 78:  /* *addqi3_non_v32 */
        case 47:  /* movstrictqi */
        case 45:  /* movstricthi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x1fULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 44:  /* movhi */
	  extract_constrain_insn_cached (insn);
	  if ((!((1ULL << which_alternative) & 0xf40ULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 37:  /* *movsi_internal */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x183fULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 219:  /* sle */
        case 218:  /* sgt */
        case 217:  /* sge */
        case 216:  /* slt */
        case 215:  /* sleu */
        case 214:  /* sgeu */
        case 213:  /* sltu */
        case 212:  /* sgtu */
        case 211:  /* sne */
        case 210:  /* seq */
        case 183:  /* cris_swap_bits */
        case 182:  /* bswapsi2 */
        case 181:  /* clzsi2 */
        case 180:  /* abssi2 */
        case 178:  /* *ashlqi_lowpart */
        case 177:  /* *ashlhi_lowpart */
        case 176:  /* ashlqi3 */
        case 175:  /* ashlhi3 */
        case 174:  /* *lshrqi_lowpart */
        case 173:  /* *ashrqi_lowpart */
        case 172:  /* *lshrhi_lowpart */
        case 171:  /* *ashrhi_lowpart */
        case 170:  /* *expanded_lshrqi */
        case 169:  /* *expanded_ashrqi */
        case 168:  /* *expanded_lshrhi */
        case 167:  /* *expanded_ashrhi */
        case 166:  /* ashlsi3 */
        case 165:  /* lshrsi3 */
        case 164:  /* ashrsi3 */
        case 163:  /* one_cmplqi2 */
        case 162:  /* one_cmplhi2 */
        case 161:  /* one_cmplsi2 */
        case 160:  /* negqi2 */
        case 159:  /* neghi2 */
        case 158:  /* negsi2 */
        case 157:  /* *expanded_negsf2 */
        case 156:  /* xorqi3 */
        case 155:  /* xorhi3 */
        case 154:  /* xorsi3 */
        case 133:  /* dstep_mul */
        case 132:  /* dstep_shift */
        case 122:  /* mstep_mul */
        case 121:  /* mstep_shift */
        case 120:  /* *addi */
        case 119:  /* addi_mul */
        case 116:  /* *boundqi_v32 */
        case 115:  /* *boundhi_v32 */
        case 114:  /* *adduqi_v32 */
        case 113:  /* *adduhi_v32 */
        case 112:  /* *addsqi_v32 */
        case 111:  /* *addshi_v32 */
        case 108:  /* *addubw_v32 */
        case 107:  /* *addsbw_v32 */
        case 105:  /* *extopqisi_v32 */
        case 104:  /* *extophisi_v32 */
        case 101:  /* *extopqihi_v32 */
        case 15:  /* *btst */
	  extract_constrain_insn_cached (insn);
	  if ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 149:  /* *iorsi3_v32 */
        case 148:  /* *iorsi3_non_v32 */
        case 137:  /* *expanded_andsi_v32 */
        case 136:  /* *expanded_andsi_non_v32 */
        case 14:  /* *cmpqi */
        case 13:  /* *cmphi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x7ULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 153:  /* *iorqi3_v32 */
        case 152:  /* *iorqi3_non_v32 */
        case 145:  /* *andqi3_v32 */
        case 144:  /* *andqi3_non_v32 */
        case 135:  /* *andsi_clear */
        case 87:  /* *subqi3_v32 */
        case 86:  /* *subhi3_v32 */
        case 85:  /* *subqi3_nonv32 */
        case 84:  /* *subhi3_nonv32 */
        case 83:  /* *subsi3_v32 */
        case 82:  /* *subsi3_non_v32 */
        case 76:  /* *addhi3_non_v32 */
        case 12:  /* *cmpsi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0xfULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 185:  /* *uminsi3_v32 */
        case 50:  /* *cris_store_multiple */
        case 49:  /* *cris_load_multiple */
        case 11:  /* *cmp_swapextqi */
        case 10:  /* *cmp_swapexthi */
        case 9:  /* *cmp_extqi */
        case 8:  /* *cmp_exthi */
	  extract_constrain_insn_cached (insn);
	  if ((which_alternative == 0) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 3:  /* *tstqi_cmp */
        case 2:  /* *tsthi_cmp */
	  extract_constrain_insn_cached (insn);
	  if ((which_alternative == 1) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 184:  /* *uminsi3_non_v32 */
        case 147:  /* *andqi_lowpart_v32 */
        case 146:  /* *andqi_lowpart_non_v32 */
        case 143:  /* *andhi_lowpart_v32 */
        case 142:  /* *andhi_lowpart_non_v32 */
        case 139:  /* *andhi_clear */
        case 138:  /* *andhi_movu */
        case 134:  /* *andsi_movu */
        case 131:  /* umulsi3_highpart */
        case 130:  /* smulsi3_highpart */
        case 110:  /* *extopqisi_swap_non_v32 */
        case 109:  /* *extophisi_swap_non_v32 */
        case 106:  /* *addxqihi_swap_non_v32 */
        case 103:  /* *extopqisi_non_v32 */
        case 102:  /* *extophisi_non_v32 */
        case 100:  /* *extopqihi_non_v32 */
        case 59:  /* zero_extendqihi2 */
        case 58:  /* zero_extendqisi2 */
        case 57:  /* zero_extendhisi2 */
        case 56:  /* extendqihi2 */
        case 55:  /* extendqisi2 */
        case 54:  /* extendhisi2 */
        case 5:  /* *tstqi_non_cmp */
        case 4:  /* *tsthi_non_cmp */
        case 1:  /* *tstsi */
	  extract_constrain_insn_cached (insn);
	  if ((((1ULL << which_alternative) & 0x3ULL)) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case -1:
	  if (GET_CODE (PATTERN (insn)) != ASM_INPUT
	      && asm_noperands (PATTERN (insn)) < 0)
	    fatal_insn_not_found (insn);
	  /* FALLTHRU */
	  extract_constrain_insn_cached (insn);
	  if ((get_attr_slottable (insn) == SLOTTABLE_YES) && ((! (
#line 193 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(RTX_FRAME_RELATED_P (insn)))) || (! (
#line 194 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(flag_exceptions)))))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        default:
	  return 0;

      }
    case 1:
      switch (recog_memoized (insn))
	{
        case 151:  /* *iorhi3_v32 */
        case 150:  /* *iorhi3_non_v32 */
        case 141:  /* *expanded_andhi_v32 */
        case 140:  /* *expanded_andhi_non_v32 */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x17ULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 127:  /* mulsi3 */
        case 126:  /* umulqihi3 */
        case 125:  /* mulqihi3 */
        case 124:  /* umulhisi3 */
        case 123:  /* mulhisi3 */
	  extract_constrain_insn_cached (insn);
	  if (! (
#line 2615 "../../gcc-10.2.1-20200826/gcc/config/cris/cris.md"
(TARGET_MUL_BUG)))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 79:  /* *addqi3_v32 */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0xffULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 77:  /* *addhi3_v32 */
        case 75:  /* *addsi3_v32 */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x7fULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 74:  /* *addsi3_non_v32 */
	  extract_constrain_insn_cached (insn);
	  if (!((1ULL << which_alternative) & 0xf0ULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 48:  /* movsf */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x171fULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 46:  /* movqi */
	  extract_constrain_insn_cached (insn);
	  if (!((1ULL << which_alternative) & 0x2c0ULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 78:  /* *addqi3_non_v32 */
        case 47:  /* movstrictqi */
        case 45:  /* movstricthi */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x1fULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 44:  /* movhi */
	  extract_constrain_insn_cached (insn);
	  if (!((1ULL << which_alternative) & 0xf40ULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 37:  /* *movsi_internal */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x183fULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 219:  /* sle */
        case 218:  /* sgt */
        case 217:  /* sge */
        case 216:  /* slt */
        case 215:  /* sleu */
        case 214:  /* sgeu */
        case 213:  /* sltu */
        case 212:  /* sgtu */
        case 211:  /* sne */
        case 210:  /* seq */
        case 183:  /* cris_swap_bits */
        case 182:  /* bswapsi2 */
        case 181:  /* clzsi2 */
        case 180:  /* abssi2 */
        case 178:  /* *ashlqi_lowpart */
        case 177:  /* *ashlhi_lowpart */
        case 176:  /* ashlqi3 */
        case 175:  /* ashlhi3 */
        case 174:  /* *lshrqi_lowpart */
        case 173:  /* *ashrqi_lowpart */
        case 172:  /* *lshrhi_lowpart */
        case 171:  /* *ashrhi_lowpart */
        case 170:  /* *expanded_lshrqi */
        case 169:  /* *expanded_ashrqi */
        case 168:  /* *expanded_lshrhi */
        case 167:  /* *expanded_ashrhi */
        case 166:  /* ashlsi3 */
        case 165:  /* lshrsi3 */
        case 164:  /* ashrsi3 */
        case 163:  /* one_cmplqi2 */
        case 162:  /* one_cmplhi2 */
        case 161:  /* one_cmplsi2 */
        case 160:  /* negqi2 */
        case 159:  /* neghi2 */
        case 158:  /* negsi2 */
        case 157:  /* *expanded_negsf2 */
        case 156:  /* xorqi3 */
        case 155:  /* xorhi3 */
        case 154:  /* xorsi3 */
        case 133:  /* dstep_mul */
        case 132:  /* dstep_shift */
        case 122:  /* mstep_mul */
        case 121:  /* mstep_shift */
        case 120:  /* *addi */
        case 119:  /* addi_mul */
        case 116:  /* *boundqi_v32 */
        case 115:  /* *boundhi_v32 */
        case 114:  /* *adduqi_v32 */
        case 113:  /* *adduhi_v32 */
        case 112:  /* *addsqi_v32 */
        case 111:  /* *addshi_v32 */
        case 108:  /* *addubw_v32 */
        case 107:  /* *addsbw_v32 */
        case 105:  /* *extopqisi_v32 */
        case 104:  /* *extophisi_v32 */
        case 101:  /* *extopqihi_v32 */
        case 15:  /* *btst */
	  return 1;

        case 149:  /* *iorsi3_v32 */
        case 148:  /* *iorsi3_non_v32 */
        case 137:  /* *expanded_andsi_v32 */
        case 136:  /* *expanded_andsi_non_v32 */
        case 14:  /* *cmpqi */
        case 13:  /* *cmphi */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x7ULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 153:  /* *iorqi3_v32 */
        case 152:  /* *iorqi3_non_v32 */
        case 145:  /* *andqi3_v32 */
        case 144:  /* *andqi3_non_v32 */
        case 135:  /* *andsi_clear */
        case 87:  /* *subqi3_v32 */
        case 86:  /* *subhi3_v32 */
        case 85:  /* *subqi3_nonv32 */
        case 84:  /* *subhi3_nonv32 */
        case 83:  /* *subsi3_v32 */
        case 82:  /* *subsi3_non_v32 */
        case 76:  /* *addhi3_non_v32 */
        case 12:  /* *cmpsi */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0xfULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 185:  /* *uminsi3_v32 */
        case 50:  /* *cris_store_multiple */
        case 49:  /* *cris_load_multiple */
        case 11:  /* *cmp_swapextqi */
        case 10:  /* *cmp_swapexthi */
        case 9:  /* *cmp_extqi */
        case 8:  /* *cmp_exthi */
	  extract_constrain_insn_cached (insn);
	  if (which_alternative == 0)
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 3:  /* *tstqi_cmp */
        case 2:  /* *tsthi_cmp */
	  extract_constrain_insn_cached (insn);
	  if (which_alternative == 1)
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case 184:  /* *uminsi3_non_v32 */
        case 147:  /* *andqi_lowpart_v32 */
        case 146:  /* *andqi_lowpart_non_v32 */
        case 143:  /* *andhi_lowpart_v32 */
        case 142:  /* *andhi_lowpart_non_v32 */
        case 139:  /* *andhi_clear */
        case 138:  /* *andhi_movu */
        case 134:  /* *andsi_movu */
        case 131:  /* umulsi3_highpart */
        case 130:  /* smulsi3_highpart */
        case 110:  /* *extopqisi_swap_non_v32 */
        case 109:  /* *extophisi_swap_non_v32 */
        case 106:  /* *addxqihi_swap_non_v32 */
        case 103:  /* *extopqisi_non_v32 */
        case 102:  /* *extophisi_non_v32 */
        case 100:  /* *extopqihi_non_v32 */
        case 59:  /* zero_extendqihi2 */
        case 58:  /* zero_extendqisi2 */
        case 57:  /* zero_extendhisi2 */
        case 56:  /* extendqihi2 */
        case 55:  /* extendqisi2 */
        case 54:  /* extendhisi2 */
        case 5:  /* *tstqi_non_cmp */
        case 4:  /* *tsthi_non_cmp */
        case 1:  /* *tstsi */
	  extract_constrain_insn_cached (insn);
	  if (((1ULL << which_alternative) & 0x3ULL))
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        case -1:
	  if (GET_CODE (PATTERN (insn)) != ASM_INPUT
	      && asm_noperands (PATTERN (insn)) < 0)
	    fatal_insn_not_found (insn);
	  /* FALLTHRU */
	  if (get_attr_slottable (insn) == SLOTTABLE_YES)
	    {
	      return 1;
	    }
	  else
	    {
	      return 0;
	    }

        default:
	  return 0;

      }
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 1;
